{system/conversion/conversion_progress.i}

/*------------------------------------------------------------------------
  File: aa/conversion/11.03/aa-1103-after-04-aa-vat_countrycode.p
  Doel: Vul de nieuwe vat_countrycode velden t.b.v. betere Xref definities.
------------------------------------------------------------------------*/
DEF VAR cProgram                      AS CHAR NO-UNDO.
DEF VAR cAction                       AS CHAR NO-UNDO.
DEF VAR iDone                         AS INT  NO-UNDO.

ASSIGN cProgram =  "aa-1103-after-04-aa-vat_countrycode.p".

FORM "Program  :" AT 1 cProgram   NO-LABEL  FORMAT "x(50)"    AT 12  SKIP
     "Action   :" AT 1 cAction    NO-LABEL  FORMAT "x(50)"    AT 12  SKIP
     "Done     :" AT 1 iDone      NO-LABEL  FORMAT "9999999"  AT 12  SKIP   
     WITH FRAME a.



  ASSIGN cAction  = "Fill new VAT country fields."
         iDone    = 0.
  RUN DisplayProgress (cProgram, cAction, ''    , 0     , iDone).
  
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/

  FOR EACH sp-company NO-LOCK: 

    cAction  = "Fill new VAT country fields : Purch.Inv.Items : " + sp-company.companycode .

    DISABLE TRIGGERS FOR LOAD OF aa-purchase_invoice_item.
    
    FOR EACH aa-purchase_invoice NO-LOCK
      WHERE aa-purchase_invoice.companycode      EQ sp-company.companycode
        AND aa-purchase_invoice.payment_status   NE 'B' ,
      EACH aa-purchase_invoice_item
      WHERE aa-purchase_invoice_item.companycode EQ sp-company.companycode
        AND aa-purchase_invoice_item.invoicenr   EQ aa-purchase_invoice.invoicenr
        AND aa-purchase_invoice_item.vat_countrycode EQ ''
        AND aa-purchase_invoice_item.vatcode         NE '' 
      TRANSACTION : 
      
      aa-purchase_invoice_item.vat_countrycode = aa-purchase_invoice.vat-countrycode .
      iDone = iDone  + 1.
      RUN DisplayProgress (cProgram, cAction, ''    , 0     , iDone).
      
    END.
    
    cAction  = "Fill new VAT country fields : Fiscal Mutation : " + sp-company.companycode .
    
    DISABLE TRIGGERS FOR LOAD OF aa-fiscal_mut.
    
    FOR EACH aa-fiscal_mut EXCLUSIVE-LOCK
      WHERE aa-fiscal_mut.companycode     EQ sp-company.companycode
        AND aa-fiscal_mut.vat_countrycode EQ ''
        AND aa-fiscal_mut.vatcode         NE '' 
      TRANSACTION : 
      
      aa-fiscal_mut.vat_countrycode = sp-company.vat_countrycode .
      iDone = iDone  + 1.
      RUN DisplayProgress (cProgram, cAction, ''    , 0     , iDone).
    
    END.
    
    cAction  = "Fill new VAT country fields : Cost Codes : " + sp-company.companycode .

    DISABLE TRIGGERS FOR LOAD OF aa-costcode.
    
    FOR EACH aa-costcode EXCLUSIVE-LOCK
      WHERE aa-costcode.companycode     EQ sp-company.companycode
        AND aa-costcode.vat_countrycode EQ ''
        AND aa-costcode.vatcode         NE ''
      TRANSACTION : 
      
      aa-costcode.vat_countrycode = sp-company.vat_countrycode .
      iDone = iDone  + 1.
      RUN DisplayProgress (cProgram, cAction, ''    , 0     , iDone).
      
    END.
    
    cAction  = " Fill new VAT country fields : Invoice Header : " + sp-company.companycode.
    
    DISABLE TRIGGERS FOR LOAD OF aa-invoice_header.
    DISABLE TRIGGERS FOR LOAD OF aa-invoice_line.
    
    FOR EACH aa-invoice_header EXCLUSIVE-LOCK
      WHERE aa-invoice_header.companycode     EQ sp-company.companycode
        AND aa-invoice_header.invoice_status  EQ ''
        AND aa-invoice_header.vat_countrycode EQ ''
      TRANSACTION :
      
      aa-invoice_header.vat_countrycode = sp-company.vat_countrycode .
      iDone = iDone  + 1.
      RUN DisplayProgress (cProgram, cAction, ''    , 0     , iDone).

      FOR EACH aa-invoice_line EXCLUSIVE-LOCK
        WHERE aa-invoice_line.companycode     EQ sp-company.companycode
          AND aa-invoice_line.keynr           EQ aa-invoice_header.keynr
          AND aa-invoice_line.vat_countrycode EQ '' :

        aa-invoice_line.vat_countrycode = aa-invoice_header.vat_countrycode .
        iDone = iDone  + 1.
        RUN DisplayProgress (cProgram, cAction, ''    , 0     , iDone).

      END.
      
    END.
    
  END. /* EACH COMPANY */
  
RUN DisplayProgress (cProgram, cAction, ''    , 0     , iDone).

