
{system/conversion/conversion_progress.i}
/*------------------------------------------------------------------------
  File: aa/conversion/12.03/aa-1203-before-01-no-doubles_aa-mail_subject.p
  Doel: - Zorgen dat na verwijderen van 'companycode' uit de index, 
          de mail_subject_code uniek is.
          Alle dubbele subjectcodes worden verwijderd, zodat er 1 unieke 
          overblijft, er zou maar 1 mogen zijn.
------------------------------------------------------------------------*/
DEF VAR cProgram                      AS CHARACTER NO-UNDO.
DEF VAR cAction                       AS CHARACTER NO-UNDO.
DEF VAR cTable                        AS CHARACTER NO-UNDO INITIAL "aa-mail_subject".
DEF VAR iDone                         AS INTEGER   NO-UNDO.
DEF VAR iTotal                        AS INTEGER   NO-UNDO INITIAL 0.
DEF VAR iLoop                         AS INTEGER   NO-UNDO.
DEF VAR iCnt                          AS INTEGER   NO-UNDO.

DEF BUFFER baa-mail_subject FOR aa-mail_subject.

  ASSIGN cProgram =  "aa-1203-before-01-no-doubles_aa-mail_subject.p".

  DISABLE TRIGGERS FOR LOAD OF aa-mail_subject.   
  DISABLE TRIGGERS FOR LOAD OF aa-mail_subject_data.   

  ASSIGN cAction  = "Make subjectcode unique in aa-mail_subject"
         cTable   = "aa-mail_subject"   
         iTotal   = 0
         iDone    = 0.
  RUN DisplayProgress (cProgram, cAction, cTable, iTotal, iDone).
  
  DO TRANSACTION:

    FOR EACH aa-mail_subject 
        EXCLUSIVE-LOCK BY mail_subject_code:
       
      FIND baa-mail_subject WHERE 
           baa-mail_subject.mail_subject_code = aa-mail_subject.mail_subject_code
           NO-LOCK NO-ERROR.
      IF AMBIGUOUS baa-mail_subject
      THEN DO: 
        FOR EACH aa-mail_subject_data WHERE
                 aa-mail_subject_data.companycode = aa-mail_subject.companycode AND 
                 aa-mail_subject_data.mail_subject_code = aa-mail_subject.mail_subject_code
                 EXCLUSIVE-LOCK:
          DELETE aa-mail_subject_data.
        END.
    
        DELETE aa-mail_subject.

        iDone = iDone  + 1.
        RUN DisplayProgress (cProgram, cAction, cTable  , iTotal     , iDone).
      END.
      iTotal = iTotal + 1.
    END.
    
  END. /* DO TRANSACTION */

  RUN DisplayProgress (cProgram, cAction, cTable    , iTotal     , iDone).




