{system/conversion/conversion_progress.i}

/*------------------------------------------------------------------------
  File: aa/conversion/13.01/aa-1301-after-03-aa-vat_countrycode.p
  Doel: Vul de nieuwe vat_countrycode velden t.b.v. betere Xref definities.
        In 11.03 bestond deze conversie al, maar hier werden alleen de 
        invoices met invoice_status ="" gevuld. Nu doen we de rest ook!
------------------------------------------------------------------------*/
  DEF VAR cProgram                      AS CHAR NO-UNDO.
  DEF VAR cAction                       AS CHAR NO-UNDO.
  DEF VAR iDone                         AS INT  NO-UNDO.
  DEF VAR iModulo                       AS INT  NO-UNDO.

  ASSIGN cProgram =  "aa-1301-after-03-aa-vat_countrycode.p".

  FORM "Program  :" AT 1 cProgram   NO-LABEL  FORMAT "x(50)"    AT 12  SKIP
       "Action   :" AT 1 cAction    NO-LABEL  FORMAT "x(50)"    AT 12  SKIP
       "Done     :" AT 1 iDone      NO-LABEL  FORMAT "9999999"  AT 12  SKIP   
       WITH FRAME a.


  ASSIGN cAction  = "Fill VAT country fields."
         iDone    = 0
         iModulo  =  1000.
  RUN DisplayProgress (cProgram, cAction, ''    , 0     , iDone).
  
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/

  FOR EACH sp-company NO-LOCK: 

    cAction  = "Fill VAT country fields : Invoices : " + sp-company.companycode .
    
    DISABLE TRIGGERS FOR LOAD OF aa-invoice_header.
    DISABLE TRIGGERS FOR LOAD OF aa-invoice_line.

    FOR EACH aa-invoice_header EXCLUSIVE-LOCK
       WHERE aa-invoice_header.companycode     EQ sp-company.companycode
         AND aa-invoice_header.dt_invoice      >= 01/01/2010
         AND aa-invoice_header.invoice_status  NE ''
         AND aa-invoice_header.vat_countrycode EQ ''
         TRANSACTION :

      ASSIGN aa-invoice_header.vat_countrycode = sp-company.vat_countrycode.
      
      FOR EACH aa-invoice_line EXCLUSIVE-LOCK
        WHERE aa-invoice_line.companycode     EQ sp-company.companycode
          AND aa-invoice_line.keynr           EQ aa-invoice_header.keynr
          AND aa-invoice_line.vat_countrycode EQ '' :

        ASSIGN aa-invoice_line.vat_countrycode = aa-invoice_header.vat_countrycode .
      END.

      iDone = iDone  + 1.
      IF iDone MODULO iModulo = 0 
      THEN RUN DisplayProgress (cProgram, cAction, ''    , 0     , iDone).

    END.

  END. /* EACH COMPANY */
  
  RUN DisplayProgress (cProgram, cAction, ''    , 0     , iDone).

