
/*------------------------------------------------------------------------
    File        : aa-2003-after-01-aa-notification.p
    Purpose     : 

    Syntax      :

    Description : 

    Author(s)   : 
    Created     : Wed Feb 14 11:34:00 CET 2018
    Notes       :
  ----------------------------------------------------------------------*/

/* ***************************  Definitions  ************************** */

&IF defined(DEBUG) > 0 &THEN
  PROCEDURE displayProgress.
    DEF INPUT PARAM pcProgram AS CHAR NO-UNDO.
    DEF INPUT PARAM pcAction  AS CHAR NO-UNDO.
    DEF INPUT PARAM pcTable   AS CHAR NO-UNDO.
    DEF INPUT PARAM piTotal   AS INT  NO-UNDO.
    DEF INPUT PARAM piDone    AS INT  NO-UNDO.
  END PROCEDURE.
&ELSE
 {System/conversion/conversion_progress.i}
&ENDIF

DEFINE VARIABLE cProgram AS CHARACTER NO-UNDO FORMAT "x(50)".
DEFINE VARIABLE cAction  AS CHARACTER NO-UNDO FORMAT "X(50)".
DEFINE VARIABLE cTable   AS CHARACTER NO-UNDO FORMAT "X(50)".
DEFINE VARIABLE iTotal   AS INTEGER   NO-UNDO.
DEFINE VARIABLE iDone    AS INTEGER   NO-UNDO.
DEFINE VARIABLE iTel     AS INTEGER   NO-UNDO.

DEF BUFFER b-aa-notification_field FOR aa-notification_field.
DEF BUFFER b-aa-notification       FOR aa-notification.

/* ********************  Preprocessor Definitions  ******************** */


/* ***************************  Main Block  *************************** */

DISABLE TRIGGERS FOR LOAD OF b-aa-notification.
DISABLE TRIGGERS FOR LOAD OF b-aa-notification_field.

ASSIGN
  cProgram = THIS-PROCEDURE:FILE-NAME
  cAction  = "Convert notifications"
  cTable   = "aa-notification"
  iTotal   = 0
  iDone    = 0.
 
RUN DisplayProgress (cProgram, cAction, cTable, iTotal, iDone).

RUN update_ssdnotifyready_org.
iTotal = 1. iDone = 1.
RUN DisplayProgress (cProgram, cAction, cTable, iTotal, iDone).

RUN update_ssdnotifynotready_org.
iTotal = 2. iDone = 2.
RUN DisplayProgress (cProgram, cAction, cTable, iTotal, iDone).

PROCEDURE add_field:
/*------------------------------------------------------------------------------
 Purpose:
 Notes:
------------------------------------------------------------------------------*/
  DEF INPUT PARAMETER pc_program_function AS CHAR NO-UNDO.
  DEF INPUT PARAMETER pc_notificationcode AS CHAR NO-UNDO.
  DEF INPUT PARAMETER pc_tablename        AS CHAR NO-UNDO.
  DEF INPUT PARAMETER pc_fieldname        AS CHAR NO-UNDO.
  DEF INPUT PARAMETER pc_des              AS CHAR NO-UNDO.
  DEF INPUT PARAMETER pc_datatype         AS CHAR NO-UNDO.
  DEF INPUT PARAMETER pc_member_of_list   AS CHAR NO-UNDO.
  DEF INPUT PARAMETER pc_subtype          AS CHAR NO-UNDO.
  
  FIND b-aa-notification_field WHERE b-aa-notification_field.program_function  = pc_program_function 
                               AND b-aa-notification_field.notificationcode  = pc_notificationcode 
                               AND b-aa-notification_field.fieldname         = pc_fieldname EXCLUSIVE-LOCK NO-ERROR.
                               
  IF NOT AVAIL b-aa-notification_field THEN 
  DO. 
    CREATE b-aa-notification_field.       
    ASSIGN b-aa-notification_field.program_function  = pc_program_function
           b-aa-notification_field.notificationcode  = pc_notificationcode.
  END.
  ASSIGN b-aa-notification_field.tablename         = pc_tablename       
         b-aa-notification_field.fieldname         = pc_fieldname       
         b-aa-notification_field.des               = pc_des             
         b-aa-notification_field.datatype          = pc_datatype        
         b-aa-notification_field.member_of_list    = pc_member_of_list  
         b-aa-notification_field.subtype           = pc_subtype.         

END PROCEDURE.

PROCEDURE content_ssdnotifyready_org:
/*------------------------------------------------------------------------------
 Purpose:
 Notes:
------------------------------------------------------------------------------*/
  DEF OUTPUT PARAMETER pcSubject AS CHAR NO-UNDO.
  DEF OUTPUT PARAMETER pcBody    AS CHAR NO-UNDO.
  
  pcSubject = "".
  pcBody    = "Your visit with visit ID [%wm-visit.visit_pinid%] is ready to process. Please return to the Self Service Desk to print your order".

END PROCEDURE.

PROCEDURE update_ssdnotifyready_org.
  DEF VAR cSubject AS CHAR NO-UNDO.
  DEF VAR cBody    AS CHAR NO-UNDO.
  
  FIND b-aa-notification WHERE b-aa-notification.program_function = "VISIT"
                           AND b-aa-notification.notificationcode = "SDDNOTIFYREADY" NO-LOCK NO-ERROR.
  IF AVAIL b-aa-notification THEN RETURN. 

  CREATE b-aa-notification.
  ASSIGN b-aa-notification.program_function = "VISIT"
         b-aa-notification.notificationcode = "SDDNOTIFYREADY"
         b-aa-notification.des              = 'Notify driver his orders are ready to process'
         b-aa-notification.date_format      = "system"
         b-aa-notification.applicatiekode   = "WM".
  
  RUN content_ssdnotifyready_org (OUTPUT cSubject, OUTPUT cBody).

  ASSIGN b-aa-notification.notification_subject = cSubject
         b-aa-notification.notification_body    = cBody.       
  
  RUN add_field ("VISIT", "SDDNOTIFYREADY", "wm-visit"   , "visit_pinid"          , "Visit ID"                     , "character", "", "normal").
  RUN add_field ("VISIT", "SDDNOTIFYREADY", "wm-visit"   , "visit_seqnr"          , "Visit No"                     , "integer"  , "", "normal").
  RUN add_field ("VISIT", "SDDNOTIFYREADY", "wm-visit"   , "transportcomp_name"   , "Transport company"            , "character", "", "normal").
  RUN add_field ("VISIT", "SDDNOTIFYREADY", "wm-visit"   , "vehicle_registration" , "Driver truck license"         , "character", "", "normal").
  RUN add_field ("VISIT", "SDDNOTIFYREADY", "wm-visit"   , "trailer_registration" , "Driver trailer license"       , "character", "", "normal").
  RUN add_field ("VISIT", "SDDNOTIFYREADY", "wm-visit"   , "driver_email"         , "Driver email"                 , "character", "", "normal").
  RUN add_field ("VISIT", "SDDNOTIFYREADY", "wm-visit"   , "driver_phone"         , "Driver phone"                 , "character", "", "normal").
  RUN add_field ("VISIT", "SDDNOTIFYREADY", "wm-visit"   , "gate_pinid"           , "Gate pincode"                 , "character", "", "normal").
  RUN add_field ("VISIT", "SDDNOTIFYREADY", "wm-visitor" , "document_id"          , "Driver document ID"           , "character", "", "normal").
  RUN add_field ("VISIT", "SDDNOTIFYREADY", "wm-visitor" , "document_firstname"   , "Driver first name"            , "character", "", "normal").
  RUN add_field ("VISIT", "SDDNOTIFYREADY", "wm-visitor" , "document_lastname"    , "Driver last name"             , "character", "", "normal").
  RUN add_field ("VISIT", "SDDNOTIFYREADY", ""           , "xrefTerminalCode"     , "Terminal"                     , "character", "", "normal").
  RUN add_field ("VISIT", "SDDNOTIFYREADY", ""           , "xrefTerminalDes"      , "Terminal description"         , "character", "", "normal").
  RUN add_field ("VISIT", "SDDNOTIFYREADY", ""           , "xrefDockNr"           , "Dock number"                  , "character", "", "normal").                   
END.

PROCEDURE update_ssdnotifynotready_org.
  DEF VAR cSubject AS CHAR NO-UNDO.
  DEF VAR cBody    AS CHAR NO-UNDO.
  
  FIND b-aa-notification WHERE b-aa-notification.program_function = "VISIT"
                         AND b-aa-notification.notificationcode = "SDDNOTIFYNOTREADY" NO-LOCK NO-ERROR.
  IF AVAIL b-aa-notification THEN RETURN. 
  
  CREATE b-aa-notification.
  ASSIGN b-aa-notification.program_function = "VISIT"
         b-aa-notification.notificationcode = "SDDNOTIFYNOTREADY"
         b-aa-notification.des              = 'Notify driver to check his phone/email regularly'
         b-aa-notification.date_format      = "system"
         b-aa-notification.applicatiekode   = "WM".
  
  RUN content_ssdnotifynotready_org (OUTPUT cSubject, OUTPUT cBody).

  ASSIGN b-aa-notification.notification_subject = cSubject
         b-aa-notification.notification_body    = cBody.       
  
  RUN add_field ("VISIT", "SDDNOTIFYNOTREADY", "wm-visit"   , "visit_pinid"          , "Visit ID"                     , "character", "", "normal").
  RUN add_field ("VISIT", "SDDNOTIFYNOTREADY", "wm-visit"   , "visit_seqnr"          , "Visit No"                     , "integer"  , "", "normal").
  RUN add_field ("VISIT", "SDDNOTIFYNOTREADY", "wm-visit"   , "transportcomp_name"   , "Transport company"            , "character", "", "normal").
  RUN add_field ("VISIT", "SDDNOTIFYNOTREADY", "wm-visit"   , "vehicle_registration" , "Driver truck license"         , "character", "", "normal").
  RUN add_field ("VISIT", "SDDNOTIFYNOTREADY", "wm-visit"   , "trailer_registration" , "Driver trailer license"       , "character", "", "normal").
  RUN add_field ("VISIT", "SDDNOTIFYNOTREADY", "wm-visit"   , "driver_email"         , "Driver email"                 , "character", "", "normal").
  RUN add_field ("VISIT", "SDDNOTIFYNOTREADY", "wm-visit"   , "driver_phone"         , "Driver phone"                 , "character", "", "normal").
  RUN add_field ("VISIT", "SDDNOTIFYNOTREADY", "wm-visitor" , "document_id"          , "Driver document ID"           , "character", "", "normal").
  RUN add_field ("VISIT", "SDDNOTIFYNOTREADY", "wm-visitor" , "document_firstname"   , "Driver first name"            , "character", "", "normal").
  RUN add_field ("VISIT", "SDDNOTIFYNOTREADY", "wm-visitor" , "document_lastname"    , "Driver last name"             , "character", "", "normal").
END.

PROCEDURE content_ssdnotifynotready_org:
/*------------------------------------------------------------------------------
 Purpose:
 Notes:
------------------------------------------------------------------------------*/
  DEF OUTPUT PARAMETER pcSubject AS CHAR NO-UNDO.
  DEF OUTPUT PARAMETER pcBody    AS CHAR NO-UNDO.
  
  pcSubject = "".
  pcBody    = "Hello [%wm-visitor.document_lastname%]," + CHR(10)
            + "One or more of your orders are not ready to process. When they become ready we will send you a message when to return to the Self Service Desk and print your order. Check your messages regularly.".

END PROCEDURE.
