
/*------------------------------------------------------------------------
    File        : aa-2101-after-01-aa-rest-api.p
    Purpose     :

    Syntax      :

    Description :

    Author(s)   :
    Created     : Wed Feb 14 11:34:00 CET 2018
    Notes       :
  ----------------------------------------------------------------------*/

/* ***************************  Definitions  ************************** */

{System/conversion/conversion_progress.i}

DEFINE VARIABLE cProgram   AS CHARACTER NO-UNDO FORMAT "x(50)".
DEFINE VARIABLE cAction    AS CHARACTER NO-UNDO FORMAT "X(50)".
DEFINE VARIABLE cTable     AS CHARACTER NO-UNDO FORMAT "X(50)".
DEFINE VARIABLE iTotal     AS INTEGER   NO-UNDO.
DEFINE VARIABLE iDone      AS INTEGER   NO-UNDO.
DEFINE VARIABLE iTel       AS INTEGER   NO-UNDO.
DEFINE VARIABLE cAppl      AS CHARACTER NO-UNDO.
DEFINE VARIABLE cKeyfields AS CHARACTER NO-UNDO.
DEFINE VARIABLE cDb        AS CHARACTER NO-UNDO.



DISABLE TRIGGERS FOR LOAD OF aa-rest_resource.

DEFINE BUFFER b-aa-rest_resource FOR aa-rest_resource.
DEFINE BUFFER b-aa-rest_resource_field FOR aa-rest_resource_field.


ASSIGN
  cProgram = THIS-PROCEDURE:FILE-NAME
  cAction  = "Convert REST resource"
  cTable   = "aa-rest_resource"
  iTotal   = 0
  iDone    = 0.

FOR EACH b-aa-rest_resource NO-LOCK :
  iTotal = iTotal + 1.
END.

RUN aaRestSystemcodes.
RUN DisplayProgress (cProgram, cAction, cTable, iTotal, iDone).

FOR EACH b-aa-rest_resource EXCLUSIVE :

  cAppl = System.cls.SpDict:spApplicationCodeFromTable(b-aa-rest_resource.tablename).

  IF CAN-FIND(FIRST sp-applicatie WHERE sp-applicatie.applicatiekode = cAppl)
  THEN b-aa-rest_resource.applicationcode = CAPS(cAppl).

  IF b-aa-rest_resource.resource_type = "D"
  THEN DO:

    cDb = SUBSTRING(b-aa-rest_resource.tablename, 1, 2).

    IF CONNECTED(cDb)
    THEN DO:
      cKeyfields = System.cls.SpDict:fetchKeyfields(
        cDb,
        b-aa-rest_resource.tablename
        ).


      FOR EACH b-aa-rest_resource_field WHERE
               b-aa-rest_resource_field.connection_profile = b-aa-rest_resource.connection_profile AND
               b-aa-rest_resource_field.resource_seqnr = b-aa-rest_resource.resource_seqnr AND
               b-aa-rest_resource_field.requirement_code = ""
               EXCLUSIVE-LOCK :
        IF LENGTH(cKeyfields) > 0 AND b-aa-rest_resource_field.fieldtype = "D" AND LOOKUP(b-aa-rest_resource_field.fieldname, cKeyfields) > 0
        THEN b-aa-rest_resource_field.requirement_code = "MAN".
        ELSE b-aa-rest_resource_field.requirement_code = "OPT".
      END.
    END.
  END.


  /* gemeenschappelijke server resources converteren */
  IF INDEX(b-aa-rest_resource.rest_resource_class, 'Salesforce.aa-rest_resource_field') > 0
  THEN b-aa-rest_resource.rest_resource_class = 'AA.cls.Rest.server.aa-rest_resource_field'.
  ELSE DO:
    IF INDEX(b-aa-rest_resource.rest_resource_class, 'Salesforce.aa-rest_resource') > 0
    THEN b-aa-rest_resource.rest_resource_class = 'AA.cls.Rest.server.aa-rest_resource'.
  END.

  IF INDEX(b-aa-rest_resource.rest_resource_class, 'Salesforce.aa-rest-systeminfo') > 0
  THEN b-aa-rest_resource.rest_resource_class = 'AA.cls.Rest.server.aa-rest-systeminfo'.

  IF INDEX(b-aa-rest_resource.rest_resource_class, 'Salesforce.aa-rest-stats') > 0
  THEN b-aa-rest_resource.rest_resource_class = 'AA.cls.Rest.server.aa-rest-stats'.


  iDone = iDone + 1.
  RUN DisplayProgress (cProgram, cAction, cTable, iTotal, iDone).
END.

RUN DisplayProgress (cProgram, cAction, cTable, iTotal, iDone).


PROCEDURE aaRestSystemcodes :

  DISABLE TRIGGERS FOR LOAD OF aa-systemcode.
  DEFINE BUFFER b-aa-systemcode FOR aa-systemcode.

  FIND b-aa-systemcode WHERE
         b-aa-systemcode.systemtype = 'rest-req'
    AND  b-aa-systemcode.systemcode = 'DEP'
    EXCLUSIVE-LOCK NO-ERROR.
  IF NOT AVAILABLE b-aa-systemcode
  THEN DO:
    CREATE b-aa-systemcode.
    ASSIGN
    b-aa-systemcode.systemtype = 'rest-req'
    b-aa-systemcode.systemcode = 'DEP'
    .
  END.
  ASSIGN
    b-aa-systemcode.volgordenr = 0
    b-aa-systemcode.des = 'Dependant on other entity'
    b-aa-systemcode.int_value = 0
    .
  FIND b-aa-systemcode WHERE
         b-aa-systemcode.systemtype = 'rest-req'
    AND  b-aa-systemcode.systemcode = 'MAN'
    EXCLUSIVE-LOCK NO-ERROR.
  IF NOT AVAILABLE b-aa-systemcode
  THEN DO:
    CREATE b-aa-systemcode.
    ASSIGN
    b-aa-systemcode.systemtype = 'rest-req'
    b-aa-systemcode.systemcode = 'MAN'
    .
  END.
  ASSIGN
    b-aa-systemcode.volgordenr = 0
    b-aa-systemcode.des = 'Mandatory'
    b-aa-systemcode.int_value = 0
    .
  FIND b-aa-systemcode WHERE
         b-aa-systemcode.systemtype = 'rest-req'
    AND  b-aa-systemcode.systemcode = 'OPT'
    EXCLUSIVE-LOCK NO-ERROR.
  IF NOT AVAILABLE b-aa-systemcode
  THEN DO:
    CREATE b-aa-systemcode.
    ASSIGN
    b-aa-systemcode.systemtype = 'rest-req'
    b-aa-systemcode.systemcode = 'OPT'
    .
  END.
  ASSIGN
    b-aa-systemcode.volgordenr = 0
    b-aa-systemcode.des = 'Optional'
    b-aa-systemcode.int_value = 0
    .


END PROCEDURE.